#include <Xm/Xm.h>
#include <Xm/DialogS.h>
#include <Xm/MainW.h>
#include <Xm/Form.h>
#include <Xm/PanedW.h>
#include <Xm/FileSB.h>
#include <Xm/MessageB.h>
#include <Xm/Label.h>
#include <Xm/PushB.h>
#include <X11/cursorfont.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>
#include <linux/errno.h>
#include "global.h"
#include "help.xbm"

void f_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget        toplevel, about_w, pane_w, form_w, label1, push1;
  Pixmap        bitmap;
  Pixel         fg, bg;
  int           item, n;
  Arg           args[5];
  static Widget fsb_ls, fsb_ss;

  void ls_cb(Widget, XtPointer, XtPointer);
  void ss_cb(Widget, XtPointer, XtPointer);
  void quit_cb(Widget, XtPointer, XtPointer);
  void fsb_cancel(Widget, XtPointer, XtPointer);
  void about_cancel(Widget, XtPointer, XtPointer);
  
  toplevel=XtParent(widget);
  while (!XtIsTopLevelShell(toplevel)) toplevel=XtParent(toplevel);

  item=(int) client_data;
  switch(item) {
  case 0:      // load setup;
    if (!fsb_ls) {
      fsb_ls=XmCreateFileSelectionDialog(toplevel, "filesb", NULL, 0);
      XtAddCallback(fsb_ls,XmNokCallback, ls_cb, NULL);
      XtAddCallback(fsb_ls,XmNcancelCallback, fsb_cancel, NULL);
      XtVaSetValues(XtParent(fsb_ls),
		    XmNtitle, "Load Setup",
		    NULL);
    }
    XtManageChild(fsb_ls);
    break;
  case 1:      // save setup;
    if (!fsb_ss) {
      fsb_ss=XmCreateFileSelectionDialog(toplevel, "filesb", NULL, 0);
      XtAddCallback(fsb_ss,XmNokCallback, ss_cb, NULL);
      XtAddCallback(fsb_ss,XmNcancelCallback, fsb_cancel, NULL);
      XtVaSetValues(XtParent(fsb_ss),
		    XmNtitle, "Save Setup",
		    NULL);
    }
    XtManageChild(fsb_ss);
    break;
  case 2:      // about;
    about_w=XtVaCreatePopupShell("About XmPStim",
				 xmDialogShellWidgetClass, toplevel,
				 XmNdeleteResponse, XmDESTROY,
				 NULL);
    pane_w=XtVaCreateWidget("pane", xmPanedWindowWidgetClass, about_w, NULL);
    form_w=XtVaCreateWidget("form1", xmFormWidgetClass, pane_w, NULL);
    XtVaGetValues(form_w, XmNforeground, &fg, XmNbackground, &bg, NULL);
    bitmap=XCreatePixmapFromBitmapData(XtDisplay(form_w),
					 RootWindowOfScreen(XtScreen(form_w)),
					 help_bits, help_width, help_height,
					 fg, bg, DefaultDepthOfScreen(XtScreen(form_w)));
    label1=XtVaCreateManagedWidget("label", xmLabelWidgetClass, form_w,
				   XmNlabelType, XmPIXMAP,
				   XmNlabelPixmap, bitmap,
				   XmNtopAttachment, XmATTACH_FORM,
				   XmNleftAttachment, XmATTACH_FORM,
				   XmNrightAttachment, XmATTACH_FORM,
				   NULL);
    push1=XtVaCreateManagedWidget("Cancel", xmPushButtonWidgetClass, form_w,
				  XmNleftAttachment, XmATTACH_FORM,
				  XmNrightAttachment, XmATTACH_FORM,
				  XmNtopAttachment, XmATTACH_WIDGET,
				  XmNtopWidget, label1,
				  XmNbottomAttachment, XmATTACH_FORM,
				  NULL);
    XtAddCallback(push1,XmNactivateCallback, about_cancel, (XtPointer)about_w);
    XtManageChild(form_w);
    XtManageChild(pane_w);
    XtPopup(about_w, XtGrabNone);
    break;
  case 3:      // quit;
    exit(0);
    break;
  }
}

/* ..................................*/
/* .....   C a l l b a c k s   ..... */
/* ................................. */

void ls_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int           i, j;
  float         ver;
  char          *filename, s[256];
  Cursor        uhr, pfeil;
  ifstream      dat;
  
  extern void update_ui();

  XmFileSelectionBoxCallbackStruct *cbs=
    (XmFileSelectionBoxCallbackStruct *) call_data;

  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    cout << "No file selected! \n";
    XtFree(filename);
    return;
  }

  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);

  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));

  /* E i n g a b e d a t e i   l e s e n   */
  dat.open(filename);
  if (!dat) {
    cout << "Cannot open file \n";
    return;
  }
  /* zuerst allgemeine Daten */
  dat >> ver >> s;
  dat >> s >> s >> s >> s >> s >> s >> s;
  /* danach Daten fr alle 8 Kanle */
  for (i=0; i<8; i++) {
    dat >> s >> msg.is_active[i] >> msg.phase[i]
	>> msg.train_l[i] >> msg.train_d[i]
	>> msg.pulse_l[i] >> msg.pulse_d[i];
  }
  update_ui();
  dat.close();
  XtFree(filename);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XtUnmanageChild(widget);
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  return;
}

void ss_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  int           i, n;
  Arg           args[5];
  static Widget fexist;
  char          *filename;
  ofstream      dat;
  extern int    errno;
  void write_setup(char *, Widget);
  void over_setup(Widget, XtPointer, XtPointer);

  XmFileSelectionBoxCallbackStruct *cbs= 
    (XmFileSelectionBoxCallbackStruct *) call_data;
  if (!XmStringGetLtoR(cbs->value, XmFONTLIST_DEFAULT_TAG, &filename)) {
    cout << "Internal error pasting filename! \n";
    return;
  }
  if (!*filename) {
    cout << "No file selected! \n";
    XtFree(filename);
    return;
  }
  dat.open(filename, ios::noreplace);
  if (errno==EEXIST) {
    if (!fexist) {
      n=0;
      XtSetArg(args[n], XmNmessageString, XmStringCreateLtoR("File already exists.\n     Overwrite?",XmFONTLIST_DEFAULT_TAG)); n++;
      XtSetArg(args[n], XmNokLabelString, XmStringCreateLocalized(" Yes ")); n++;
      XtSetArg(args[n], XmNcancelLabelString, XmStringCreateLocalized(" No ")); n++;
      XtSetArg(args[n], XmNtitle, "Save Setup"); n++;
      fexist=XmCreateQuestionDialog(widget, "fexist", args, n);
      XtAddCallback(fexist, XmNokCallback, over_setup, widget);
      XtUnmanageChild(XmMessageBoxGetChild(fexist, XmDIALOG_HELP_BUTTON));
    }
    XtManageChild(fexist);
    XtPopup(XtParent(fexist), XtGrabNone);
  }
  if (dat) {
    dat.close();
    write_setup(filename, widget);
  }
  XtFree(filename);
  return;
}

void quit_cb(Widget widget, XtPointer client_data, XtPointer call_data) {
  exit(0);
}

void fsb_cancel(Widget widget, XtPointer client_data, XtPointer call_data) {
  XtUnmanageChild(widget);
}

void about_cancel(Widget widget, XtPointer client_data, XtPointer call_data) {
  Widget about_w=(Widget) client_data;
  XtDestroyWidget(about_w);
}

void write_setup(char *filename, Widget widget) {
  Cursor        uhr, pfeil;
  ofstream      dat;
  int           i, j;

  /* A u s g a b e d a t e i   s c h r e i b e n   */
  // cursor setzen;
  uhr  =XCreateFontCursor(XtDisplay(widget),XC_watch);
  pfeil=XCreateFontCursor(XtDisplay(widget), XC_arrow);
  XDefineCursor(XtDisplay(widget),XtWindow(widget),uhr);
  XFlush(XtDisplay(widget));

  // Open File;
  dat.open(filename);
  if (!dat) {
    cout << "Cannot open file for output \n";
    return;
  }

  /* zuerst allgemeine Daten */
  dat << -atof(VERSION) << "\t XmPStim\n";
  dat << "Channel\tActive\tPhase\tTP\tTD\tPP\tPD\n";
  /* danach Daten fr alle 8 Kanle */
  for (i=0; i<8; i++)  {
    dat << i << ":\t"
	<< msg.is_active[i] << "\t"
	<< msg.phase[i] << "\t"
	<< msg.train_l[i] << "\t"
	<< msg.train_d[i] << "\t"
	<< msg.pulse_l[i] << "\t"
	<< msg.pulse_d[i] << "\n";
  }
  dat.close();
  XDefineCursor(XtDisplay(widget),XtWindow(widget),pfeil);
  XtUnmanageChild(widget);
  XFreeCursor(XtDisplay(widget), pfeil);
  XFreeCursor(XtDisplay(widget), uhr);
  return;
}

void over_setup(Widget w, XtPointer client_data, XtPointer call_data) {
  XmString fname;
  char     *filename;
  XtVaGetValues((Widget)client_data, XmNdirSpec, &fname, NULL);
  XmStringGetLtoR(fname, XmFONTLIST_DEFAULT_TAG, &filename);
  write_setup(filename, (Widget)client_data);
  XmStringFree(fname);
  XtFree(filename);
}
